# $TSUKUBA_Release: Omni OpenMP/XcalableMP Compiler Software Version 0.5.1 $
# $TSUKUBA_Copyright:
#  Copyright (C) 2010 University of Tsukuba
#  
#  This software is free software; you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License version
#  2.1 published by the Free Software Foundation.
#  
#  Please check the Copyright and License information in the files named
#  COPYRIGHT and LICENSE under the top  directory of the Omni Compiler
#  Software release kit.
#  
#  * The specification of XcalableMP has been designed by the XcalableMP
#    Specification Working Group (http://www.xcalablemp.org/).
#  
#  * The development of this software is supported by "Seamless and
#    Highly-productive Parallel Programming Environment for
#    High-performance computing" project funded by Ministry of Education,
#    Culture, Sports, Science and Technology, Japan.
#  $
abspath()
{
    cd $1 > /dev/null
    if [ $? != 0 ]; then
        echo file not found : $1
    fi
    echo $PWD
    cd - > /dev/null
}

work=`abspath ../..`
export OMNI_HOME=$work
frontend=$work/F-FrontEnd/src/F_Front
backend=$work/F-BackEnd/bin/F_Back
nativecomp=gfortran
tmpdir=$work/compile
testdata=$work/F-FrontEnd/test/testdata

chmod +x $backend
if [ ! -e "$tmpdir" ]; then
    mkdir $tmpdir
fi

cd $tmpdir
if [ $? != 0 ]; then
    exit 1
fi

ulimit -t 10

echo > errors.txt

for f in $testdata/*.f $testdata/*.f90; do
    b=`basename $f`
    $frontend -I $testdata $f -o $b.xml > $b.out 2>&1
    if [ $? = 0 ]; then
        $backend $b.xml -o $b.dec.f90 >> $b.out 2>&1
        if [ $? = 0 ]; then
            $nativecomp -c $b.dec.f90 -o $b.o >> $b.out 2>&1
            if [ $? = 0 ]; then
                echo ok: $b
            else
                echo --- failed native: $b | tee -a errors.txt
            fi
        else
            echo --- failed backend: $b | tee -a errors.txt
        fi
    else
        echo --- failed frontend: $b | tee -a errors.txt
    fi
done

